SETREUID(2)

NAME
setreuid - set real and effective user ID's

SYNOPSIS
#include <unistd.h>
int
setreuid(int ruid, int euid);

DESCRIPTION
The real and effective user ID's of the current process are set according to the arguments. If the real user ID is changed, the saved user ID is changed to the new value of the effective user ID.

If ruid or euid is -1, the current uid is filled in by the system. Unprivileged users may change the real user ID to the effective user ID, and may change the effective user ID to the real user ID or the saved user ID; only the super-user may make other changes.

The setreuid() function has been used to swap the real and effective user IDs in set-user-ID programs to temporarily relinquish the set-user-ID value. This purpose is now better served by the use of the seteuid() function (see setuid(2) ).

When setting the real and effective user IDs to the same value, this function is equivalent to the setuid() function. When setting only the effective user ID, this function is equivalent to the seteuid() function.

RETURN VALUES
Upon successful completion, a value of 0 is returned. Otherwise, a value of -1 is returned and errno is set to indicate the error.

ERRORS

[EPERM]
    The current process is not the super-user and a change other than changing the effective user-id to the real user-id was specified.

SEE ALSO
getuid(2), seteuid(2), setuid(2), setgid(2)

HISTORY
The setreuid() function call appeared in 4.2BSD and was dropped in 4.4BSD. It was reimplemented in NetBSD 1.2 in a way compatible with 4.3BSD, SunOS and Linux.